#!/usr/local/bin/perl -w
our $myname = 'mixi2rss v.0.11 (Release 1015)';
;#			Programmed by Piroli YUKARINOMIYA <piroli@magicvox.net>
;#			@see http://www.magicvox.net/archive/2005/09022203.php
;#			Original Concept by antipop2.0
;#			@see http://antipop.gs/mt/2004/05/13/222355

BEGIN {
	;### CPAN W[݂̍菈
	;### OŃCXg[W[w悤ύXĂ
	unshift @INC, '/home/magicvox/www/cgi-bin/mt/extlib';
}
use strict;
use warnings;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use WWW::Mechanize;
use Template::Extract;
use Jcode;

;########################################################################
;### Ȃ̃OCp[AhX
our $mailaddr = 'yourname@yourdomain.com';
;### Ȃ̃OCppX[h
our $password = 'yourpassword';

;### NGXg̃y[WN[Ԋu
our $waittime = 1;# b

;### ftHgŎ擾ACe̍ő吔
our $maxitemcount = 50;



;########################################################################
our $base_uri = 'http://mixi.jp/';
my $query = CGI->new;
$maxitemcount = $query->param("lastn") if (defined $query->param("lastn"));
$maxitemcount = 10 if ($maxitemcount < 10);
$maxitemcount = 100 if (100 < $maxitemcount);

if (defined $query->param("mode")) {
	if ($query->param("mode") eq "diary") {
		if ($query->param("id")) {
			;### 
		} else {
			;### }C~NVBŐVL
			&makeRSS (&mixiParseNewFriendDiary ());
			exit;
		}
	} elsif ($query->param("mode") eq "community") {
		if ($query->param("id")) {
			;### 
		} else {
			;### R~jeBŐV
			&makeRSS (&mixiParseNewBBS ());
			exit;
		}
	} elsif ($query->param("mode") eq "album") {
		if ($query->param("id")) {
			;### 
		} else {
			;### Ao
			&makeRSS (&mixiParseNewAlbum ());
			exit;
		}
	} elsif ($query->param("mode") eq "message") {
		;### bZ[W
		&makeRSS (&mixiParseMessageList ());
		exit;
	} elsif ($query->param("mode") eq "footprint") {
		;### 
		&makeRSS (&mixiParseFootPrint ());
		exit;
	}
}
;### Error
print "Content-type: text/plain\n\nError; Invalid Query\n";
exit;



;########################################################################
;### }C~NVBŐVL(new_friend_diary.pl)̉
sub mixiParseNewFriendDiary
{
	my $template = << '__HTMLPATTERN__';
<td [% ... %]><font [% ... %]><b>[% title %]</b>[% ... %]</td></tr>
[% ... %]
<table [% ... %]>
<tr><td>
<table [% ... %]>[% FOREACH items %]
<tr [% ... %]>
<td [% ... %]><img [% ... %]>[% year %]N[% month %][% day %] [% hour %]:[% minute %]</td>
<td [% ... %]><a [% ... %] href=[% url %]>[% title %]</a> ([% author %]) 
[% ... %]
[% END %]</table>
</td></tr>
</table>

__HTMLPATTERN__

	my $filepath = 'new_friend_diary.pl';
	my $ext;
	my @items = ();
	for (my $page = 1; $page <= 5; $page++) {
		my $contents = Jcode->new (&mixiGetPage ($filepath. '?page='. $page))->h2z->sjis;
		my $obj = Template::Extract->new;
		my $ret = $obj->extract ($template, $contents);
		last if (! defined $ret);
		$ext = $ret;
		@items = (@items, @{$ret->{items}});
		last if ($maxitemcount <= $#items);
		sleep ($waittime);
	}
	$ext->{items} = \@items;
	$ext->{url} = $filepath;
	return $ext;
}

;########################################################################
;### R~jeBŐV(new_bbs.pl)̉
sub mixiParseNewBBS
{
	my $template = << '__HTMLPATTERN__';
<td [% ... %]><font [% ... %]><b>[% title %]</b>[% ... %]</td></tr>
[% ... %]
<table [% ... %]>[% FOREACH items %]
<tr [% ... %]>
<td [% ... %]><img [% ... %]>[% year %]N[% month %][% day %] [% hour %]:[% minute %]</td>
<td [% ... %]>
<a href="[% url %]" [% ... %]>[% title %] ([% ... %])</a> ([% author %])
[% ... %]
[% END %]</table>
__HTMLPATTERN__

	my $filepath = 'new_bbs.pl';
	my $ext;
	my @items = ();
	for (my $page = 1; $page <= 5; $page++) {
		my $contents = Jcode->new (&mixiGetPage ($filepath. '?page='. $page))->h2z->sjis;
		my $obj = Template::Extract->new;
		my $ret = $obj->extract ($template, $contents);
		last if (! defined $ret);
		$ext = $ret;
		@items = (@items, @{$ret->{items}});
		last if ($maxitemcount <= $#items);
		sleep ($waittime);
	}
	$ext->{items} = \@items;
	$ext->{url} = $filepath;
	return $ext;
}

;########################################################################
;### VAo(new_album.pl)̉
sub mixiParseNewAlbum
{
	my $template = << '__HTMLPATTERN__';
<td [% ... %]><font [% ... %]><b>[% title %]</b></td></tr>
[% ... %]
<table [% ... %]>[% FOREACH items %]
[% ... %]
<tr [% ... %]>
<td [% ... %]><img [% ... %]>[% year %]N[% month %][% day %] [% hour %]:[% minute %]</td>
<td [% ... %]><a href=[% url %]>[% title %]</a> ([% author %])
[% ... %]
[% END %]</table>
__HTMLPATTERN__

	my $filepath = 'new_album.pl';
	my $ext;
	my @items = ();
	for (my $page = 1; $page <= 5; $page++) {
		my $contents = Jcode->new (&mixiGetPage ($filepath. '?page='. $page))->h2z->sjis;
		my $obj = Template::Extract->new;
		my $ret = $obj->extract ($template, $contents);
		last if (! defined $ret);
		$ext = $ret;
		@items = (@items, @{$ret->{items}});
		last if ($maxitemcount <= $#items);
		sleep ($waittime);
	}
	$ext->{items} = \@items;
	$ext->{url} = $filepath;
	return $ext;
}

;########################################################################
;### bZ[Wꗗ(new_bbs.pl)̉
sub mixiParseMessageList
{
	my $template = << '__HTMLPATTERN__';
<td [% ... %]><img [% ... %]><b><font [% ... %]>[% title %]</font></b></td></tr>
[% ... %]
<tr>
<td [% ... %]><img [% ... %]></td></tr>[% FOREACH items %]
[% ... %]
<tr [% ... %]>
<td [% ... %]><img [% ... %]></td>
<td><input [% ... %]></td>
<td>[% author %]</td>
<td><a HREF="[% url %]">[% title %]</a></td>
<td>[% month %][% day %]</td></tr>
<tr>
<td [% ... %]><img [% ... %]></td></tr>
[% END %]</table>
__HTMLPATTERN__

	my $filepath = 'list_message.pl';
	my $ext;
	my @items = ();
	for (my $page = 1; $page <= 5; $page++) {
		my $contents = Jcode->new (&mixiGetPage ($filepath. '?box=inbox&page='. $page))->h2z->sjis;
		my $obj = Template::Extract->new;
		my $ret = $obj->extract ($template, $contents);
		last if (! defined $ret);
		$ext = $ret;
		@items = (@items, @{$ret->{items}});
		last if ($maxitemcount <= $#items);
		sleep ($waittime);
	}
	$ext->{items} = \@items;
	$ext->{url} = $filepath;
	return $ext;
}


;########################################################################
;### (show_log.pl)̉
sub mixiParseFootPrint
{
	my $template = << '__HTMLPATTERN__';
<td [% ... %]><b>[% title %]</b></td></tr>
[% ... %]
<td class=h130>[% FOREACH items %]
[% ... %]
[% year %]N[% month %][% day %] [% hour %]:[% minute %] <a href="[% url %]">[% title %]</a><br>
[% ... %]
[% END %]</td></tr>
__HTMLPATTERN__

	my $filepath = 'show_log.pl';
	my $ext;
	my @items = ();
	for (my $page = 1; $page <= 1; $page++) {
		my $contents = Jcode->new (&mixiGetPage ($filepath))->h2z->sjis;
		my $obj = Template::Extract->new;
		my $ret = $obj->extract ($template, $contents);
		last if (! defined $ret);
		$ext = $ret;
		@items = (@items, @{$ret->{items}});
		last if ($maxitemcount <= $#items);
		sleep ($waittime);
	}
	$ext->{items} = \@items;
	$ext->{url} = $filepath;
	return $ext;
}



;########################################################################

;### mixi y[W擾
our $mech = undef;
sub mixiGetPage
{
	my ($filepath) = @_;
	if (! $mech) {
		$mech = WWW::Mechanize->new ();
		$mech->agent_alias ('Windows Mozilla');
		$mech->get ($base_uri);
		$mech->form_number ('1');
		$mech->field ('email', $mailaddr);
		$mech->field ('password', $password);
		$mech->submit ();
	}
	$mech->get ($base_uri. $filepath);
	return $mech->content ();
}

;### Decoding of HTML Entity
sub decode_html {
	my ($html) = @_;
	return '' unless defined $html;
	$html =~ tr!\cM!!d;
	$html =~ s!&quot;!"!g;  #"
	$html =~ s!&lt;!<!g;
	$html =~ s!&gt;!>!g;
	$html =~ s!&amp;!&!g;
	$html;
}


;### Encoding of XML Entity
sub encode_xml {
	my %Map = (
			'&' => '&amp;', '"' => '&quot;',
			'<' => '&lt;', '>' => '&gt;',
			'\'' => '&apos;');
	my $RE = join '|', keys %Map;
    my ($str) = @_;
	$str = decode_html ($str);# orz
    $str =~ s!($RE)!$Map{$1}!g;
	$str;
}

;### RSS 𐶐 Ⴎ
sub makeRSS
{
	my $rss_data = shift;
	$rss_data->{title} = encode_xml (Jcode->new ($rss_data->{title})->h2z->utf8);

	my $output =<< "__RSSDATA__";
<?xml version="1.0" encoding="UTF-8"?>

<rdf:RDF
 xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
 xmlns:dc="http://purl.org/dc/elements/1.1/"
 xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
 xmlns:admin="http://webns.net/mvcb/"
 xmlns:cc="http://web.resource.org/cc/"
 xmlns="http://purl.org/rss/1.0/"
>

<channel rdf:about="${base_uri}$rss_data->{url}">
<title>$rss_data->{title}</title>
<link>${base_uri}$rss_data->{url}</link>
<description>$rss_data->{title} by $myname</description>
<dc:language>ja</dc:language>
<dc:creator></dc:creator>

<items><rdf:Seq>
__RSSDATA__

for my $item (@{$rss_data->{items}}) {
	$item->{url} =~ s/&/&amp;/;
	$output .=<< "__RSSDATA__";
<rdf:li rdf:resource="${base_uri}$item->{url}" />
__RSSDATA__
}

	$output .=<< "__RSSDATA__";
</rdf:Seq></items></channel>
__RSSDATA__

for my $item (@{$rss_data->{items}}) {
	$item->{title} = encode_xml (Jcode->new ($item->{title})->h2z->utf8);
	$item->{author} = encode_xml (Jcode->new ($item->{author})->h2z->utf8);
	$item->{year} = 2005 if ($item->{year} == 0);
	$item->{year} = sprintf ("%04d", $item->{year});
	$item->{month} = sprintf ("%02d", $item->{month});
	$item->{day} = sprintf ("%02d", $item->{day});
	$item->{hour} = sprintf ("%02d", $item->{hour} + 0);
	$item->{minute} = sprintf ("%02d", $item->{minute} + 0);
	$output .=<< "__RSSDATA__";
<item rdf:about="${base_uri}$item->{url}">
<title>$item->{title}</title>
<link>${base_uri}$item->{url}</link>
<dc:subject>$item->{author}</dc:subject>
<dc:creator>$item->{author}</dc:creator>
<dc:date>$item->{year}-$item->{month}-$item->{day}T$item->{hour}:$item->{minute}:00+09:00</dc:date>
</item>
__RSSDATA__
}

	$output .=<< "__RSSDATA__";
</rdf:RDF>
__RSSDATA__

	print "Content-type: application/xml; charset=UTF-8\n\n";
#	print Jcode->new ($output)->h2z->utf8;
	print $output;
}
__END__